// diff_comp.c
// $Id: diff_comp.c,v 1.2 2007/07/13 06:51:07 sendan Exp $
// masashi shimakura


#include<stdio.h>
#include<stdlib.h>

#include "almemsys.h"
#include "difference.h"



char * diff_comp(char * difference_data)
{
int count, new_len, math, num, splen, pointlen, inret, e_base, e_count, m_count, m_base;
char * plus_data;
char * swap_data;
private_data_diff *pd;

// バッファーのセット
count = 0, new_len = 0, math = 0, num = 0, splen = 0, pointlen = 0, inret = 0;

if((plus_data = (char *)calloc(2, sizeof(char)))==NULL){exit(1);}
if((swap_data = (char *)calloc(2, sizeof(char)))==NULL){exit(1);}
if((pd = (private_data_diff *)malloc(sizeof(private_data_diff)))==NULL){exit(1);}


// 0x01が含まれないことを確認
if(char_count(difference_data, (char)0x01)){
   free(plus_data);
   free(swap_data);
   free(pd);
   difference_data = safe_memcpy(difference_data, "\n", MAX_BUFF_COUNT);
   return(difference_data);
   }


// 差分データを小分け、配列に入れる
new_len = char_count(difference_data, '\n');
diff_private_malloc_set_new(pd, new_len);

for(count = 0; count < new_len; count++){
   swap_data = delim_get(difference_data, swap_data, '\n', &inret, count);

   splen = char_count(swap_data, ' ');
   if(splen == 1){
      pointlen = char_point(swap_data, ' ', 1);
      swap_data[pointlen] = (char)0x01;
      }
   else if(splen > 1){
      pointlen = char_point(swap_data, ' ', 1);
      swap_data[pointlen] = (char)0x01;
      pointlen = char_point(swap_data, ' ', 1);
      swap_data[pointlen] = (char)0x01;
      }
   else{
      swap_data = safe_memcpy(swap_data,"\n", MAX_BUFF_COUNT);
      }

   #ifdef COMP_DEBUG_1
   printf("=%d=====%s\n", pointlen, swap_data);
   #endif

   plus_data = safe_memcpy(plus_data, "\n", BUF_MAX);
   plus_data = delim_get(swap_data, plus_data, (char)0x01, &inret, 0);

   if     (0 == self_memcmp(plus_data, "+")){ math = 1; }
   else if(0 == self_memcmp(plus_data, "-")){ math = 0; }
   else if(0 == self_memcmp(plus_data, "=")){ math = 2; }
   else{ math = 0; }

   plus_data = safe_memcpy(plus_data, "\n", BUF_MAX);
   plus_data = delim_get(swap_data, plus_data, (char)0x01, &inret, 1);

   num = strtol(plus_data, (char **)NULL, 10);

   if(math == 1){
      plus_data = safe_memcpy(plus_data, "\n", BUF_MAX);
      plus_data = delim_get(swap_data, plus_data, (char)0x01, &inret, 2);
      }

   pd->math[count] = math;
   math = 0;
   pd->num[count] = num;
   num = 0;
   pd->new_data[count] = safe_memcpy(pd->new_data[count], plus_data, MAX_BUFF_COUNT);

   #ifdef COMP_DEBUG_1
   printf("math=%d num=%d data=%s\n", pd->math[count], pd->num[count], pd->new_data[count]);
   #endif
   }


// データを圧縮 
e_count = 0;
e_base = 0;
m_count = 0;
m_base = 0;

difference_data = safe_sprintf(difference_data, MAX_BUFF_COUNT, "%c%c", (char)0x00, (char)0x00);
 
for(count = 0; count < new_len; count++){

   // (+) section
   if(pd->math[count] == 1){
      #ifdef COMP_DEBUG_1
      printf("=(+)==%d=%s\n", count, pd->new_data[count]);
      #endif
      swap_data = safe_sprintf(swap_data, MAX_BUFF_COUNT,"+ %d %s\n",
         pd->num[count], pd->new_data[count]);
      difference_data = safe_strncat(difference_data, swap_data, MAX_BUFF_COUNT);
      }

   // (-) section
   else if(pd->math[count] == 0){
      #ifdef COMP_DEBUG_1
      printf("=(-)==%d=\n", count);
      #endif
      if(m_count == 0){
         m_base = pd->num[count];
         }
      if((count + 1) < new_len){
         if(pd->math[count + 1] == 0){
            m_count++;
            }
         else{
            swap_data = safe_sprintf(swap_data, MAX_BUFF_COUNT,"- %d %d\n",
               m_base, (m_count + m_base));
            difference_data = safe_strncat(difference_data, swap_data, MAX_BUFF_COUNT);
            m_base = 0; m_count = 0;
            }
         }
      else{
         if(m_base == 0 && m_count == 0){
            m_base = count;
            }
         swap_data = safe_sprintf(swap_data, MAX_BUFF_COUNT,"- %d %d\n",
            m_base, (m_count + m_base));
         difference_data = safe_strncat(difference_data, swap_data, MAX_BUFF_COUNT);
         m_base = 0; m_count = 0;
         }
      }

   // (=) section
   else if(pd->math[count] == 2){
      #ifdef ON_DEBUG_1
      printf("=(=)==%d=\n", count);
      #endif

      if(e_count == 0){
         e_base = pd->num[count];
         }

      if((count + 1) < new_len){
         if(pd->math[count + 1] == 2 && pd->num[count + 1] == (pd->num[count]+1) ){
            e_count++;
            }
         else{
            swap_data = safe_sprintf(swap_data, MAX_BUFF_COUNT,"= %d %d\n",
               e_base, (e_count + e_base));
            difference_data = safe_strncat(difference_data, swap_data, MAX_BUFF_COUNT);
            e_base = 0; e_count = 0;
            }
         }
      // 最後の行の処理
      else{
         if(e_base == 0 && e_count == 0){
            e_base = count;
            }
         swap_data = safe_sprintf(swap_data, MAX_BUFF_COUNT,"= %d %d\n",
            e_base, (e_count + e_base));
         difference_data = safe_strncat(difference_data, swap_data, MAX_BUFF_COUNT);
         e_base = 0; e_count = 0;
         }
      }

   // (other) section
   else{
      #ifdef ON_DEBUG_1
      printf("=(other)=\n");
      #endif
      }

   }


// バッファーの開放
diff_private_malloc_free_new(pd, new_len);

free(plus_data);
free(swap_data);
free(pd);

return(difference_data);
}




