// scan_port.c	
// $Id: scan_port.c,v 1.1.1.1 2007/06/26 07:58:40 sendan Exp $
// masashi shimakura


#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include<pthread.h>
#include"sitar.h"
#include"sitar_scan.h"
#include"almemsys.h"

/* 0 -> ch_stat       char*  open sccses = 0, not open sccses is !0 
   1 -> ch_prot       char*  for 'TCP,UDP,ICMP'
   2 -> ch_host       char*  127.0.0.1
   3 -> ch_port       char*  0~100000 Listn ports
        port          int
   4 -> ch_timeuot    char*  1 = 1sec
        timeout       int
   5 -> ch_info       char*  check cliants infolmationes

   needid file is 
   scan_udpport.c, scan_icmp.c, scan_tcpport.c
*/

/*
int scan_port(struct scan_buf *);
*/


/* ------ SCAN PORT --------- */
int scan_port(struct scan_buf *pd)
{
int ret = -1;
int inA = 0;
int inB = 0;
int out = 1;
char * info_swap;

info_swap = (char *)calloc(IP_LEN, sizeof(char));

if((memcmp(pd->ch_prot, "HOST", 4)) == 0){
   pd->ch_info = scan_host(pd->ch_com, pd->ch_host, pd->ch_info, pd->timeout, &ret);
   if(0 == (int)strlen(pd->ch_info)){
      pd->ch_info=safe_memcpy(pd->ch_info,"Information is a no bur error.\n",BUF_MAX);
      }
   }

if((memcmp(pd->ch_prot, "SNTP", 4)) == 0){
   pd->ch_info = scan_sntp_connect(123, pd->ch_host, pd->ch_info, pd->timeout, &ret);
   if(0 == (int)strlen(pd->ch_info)){
      pd->ch_info=safe_memcpy(pd->ch_info,"Information is a no bur error.\n",BUF_MAX);
      }
   }

if((memcmp(pd->ch_prot, "ICMP", 4)) == 0){
   pd->ch_info=scan_icmp(pd->ch_host, pd->ch_info, pd->timeout, &ret);
   if(0 == (int)strlen(pd->ch_info)){
      pd->ch_info=safe_memcpy(pd->ch_info,"Information is a no bur error.\n",BUF_MAX);
      }
   }

if((memcmp(pd->ch_prot,"URL", 3)) == 0){
   pd->ch_info=scan_url_connect(pd->port, pd->ch_host, pd->ch_info, pd->timeout, &ret);
   if(0 == (int)strlen(pd->ch_info)){
      pd->ch_info=safe_memcpy(pd->ch_info,"Information is a no bur error.\n",BUF_MAX);
      }
   }

if((memcmp(pd->ch_prot,"SMTP", 4)) == 0){
   pd->ch_info = scan_smtp_connect(pd->port,pd->ch_host,pd->ch_info,pd->timeout,&ret);
   if(0 == (int)strlen(pd->ch_info)){
      pd->ch_info=safe_memcpy(pd->ch_info,"Information is a no bur error.\n",BUF_MAX);
      }
   }

if((memcmp(pd->ch_prot,"DHW", 3)) == 0){
   pd->ch_info = scan_dhw_connect(pd->ch_com, pd->port, pd->ch_host, pd->ch_info, pd->timeout,&ret);
   if(0 == (int)strlen(pd->ch_info)){
      pd->ch_info=safe_memcpy(pd->ch_info,"Information is a no bur error.\n",BUF_MAX);
      }
   }

if((memcmp(pd->ch_prot, "TCP", 3)) == 0){
   pd->ch_info=scan_tcp_connect(pd->port, pd->ch_host, pd->ch_info, pd->timeout, &ret);
   if(0 == (int)strlen(pd->ch_info)){
      pd->ch_info=safe_memcpy(pd->ch_info,"Information is a no bur error.\n",BUF_MAX);
      }
   }

if((memcmp(pd->ch_prot, "UDP", 3)) == 0){

   info_swap = scan_icmp(pd->ch_host, info_swap, pd->timeout, &inA);
   pd->ch_info = scan_udp_connect(pd->port, pd->ch_host, pd->ch_info, pd->timeout, &inB);

   if(inA == 0 && inB == 0){
      ret = 0;
      }

   if(inA != 0 && inB == 0){
      ret = -3;
      #ifdef SCAN_PORT_DEBUG
      fprintf(stderr,"SCAN_PORT: scan_port(): %s non icmp support or not server\n", pd->ch_host);
      #endif
//      pd->ch_info = safe_sprintf(pd->ch_info, BUF_MAX,
//            "%s ICMP is not support or there is no server. ", pd->ch_host);
      pd->ch_info = safe_sprintf(pd->ch_info, BUF_MAX,
            "%s %s. ", pd->ch_host, info_swap);
      }

   if(inA != 0 && inB != 0){
      ret = -2;
      #ifdef SCAN_PORT_DEBUG
      fprintf(stderr,"SCAN_PORT: scan_port(): %s is not server\n", pd->ch_host);
      #endif
      }

   if(inA == 0 && inB != 0){
      ret = -1;
      #ifdef SCAN_PORT_DEBUG
      fprintf(stderr,"SCAN_PORT: scan_port(): %s is icmp support ok. bat <port=%d> is not open\n",
      pd->ch_host, pd->port);
      #endif
      }

   if(0 == (int)strlen(pd->ch_info)){
      pd->ch_info=safe_memcpy(pd->ch_info,"Information is a no bur error.\n",BUF_MAX);
      }
   }


/* test mode chack */
if(0 == memcmp(pd->ch_plai, "4", 1)){
   out = 4;
   #ifdef SCAN_PORT_DEBUG
   printf("SCAN_PORT: scan_port(): port chack out = %d\n", out);
   #endif
   }
if(out == 4){
   if(2 > strlen(pd->ch_info)){
      pd->ch_info = safe_memcpy(pd->ch_info, "Ǥºݤͤ򲼤ƥ顼Ф뤫ǧƤ", BUF_MAX );
      }
   ret = -1;
   }
/* */




if(ret < 0){

   if(pd->ch_stat[0] == '0'){
      pd->check_stat = 1;
      }

   if(pd->ch_stat[0] == '1'){
      pd->check_stat = 0;
      }

   }

if(ret >= 0){

   if(pd->ch_stat[0] == '1'){
      pd->check_stat = 1;
      }

   if(pd->ch_stat[0] == '0'){
      pd->check_stat = 0;
      }

   }

free(info_swap);

return 0;
}



