// times.c
// $Id: times.c,v 1.1.1.1 2007/06/26 07:58:40 sendan Exp $
// masashi shimakura

/* FreeBSD */
#include<stdio.h>
#include<unistd.h>
#include<netinet/in.h>
#include<string.h>
#include<stdlib.h>
#include<time.h>
#include<arpa/inet.h>
#include<pthread.h>

#include"zither.h"
#include"almemsys.h"

/*
int time_getr(char [], int);
long int u_time(void);
int mail_time_getr(char [], int, char *);
long int ctime_getr(char);
*/


char * char_wday(int);
char * char_mon(int);

extern struct buff_set bf;




char * char_wday(int wday)
{
static char * ret;
switch(wday){
    case 0 : ret = "Sun"; break;
    case 1 : ret = "Mon"; break;
    case 2 : ret = "Tue"; break;
    case 3 : ret = "Wed"; break;
    case 4 : ret = "Thu"; break;
    case 5 : ret = "Fri"; break;
    case 6 : ret = "Sat"; break;
    default : ret = "Not!"; break;
    }
return(ret);
}


char * char_mon(int mon)
{
static char * ret;
switch(mon){
    case 0 : ret = "Jan"; break;
    case 1 : ret = "Feb"; break;
    case 2 : ret = "Mar"; break;
    case 3 : ret = "Apr"; break;
    case 4 : ret = "May"; break;
    case 5 : ret = "Jun"; break;
    case 6 : ret = "Jul"; break;
    case 7 : ret = "Aug"; break;
    case 8 : ret = "Sep"; break;
    case 9 : ret = "Oct"; break;
    case 10 : ret = "Nov"; break;
    case 11 : ret = "Dec"; break;
    default : ret = "Not!"; break;
    }
return(ret);
}




/* -------------- u_time --------------- */
long int u_time(void)
{
static time_t tt;
tt = time(NULL);
return((long int)tt);
}




/* ------------ mail_time_getr --------------- */
int mail_time_getr(char buf[], int count, char * zone)
{
time_t t;
struct tm tmbuf;

t = time(NULL);
localtime_r(&t, &tmbuf);

if(20<=count){
   sprintf(buf,"%s, %02d %s %04d %02d:%02d:%02d %s",
      (char *)char_wday(tmbuf.tm_wday),
      tmbuf.tm_mday,
      (char *)char_mon(tmbuf.tm_mon),
      tmbuf.tm_year + 1900,
      tmbuf.tm_hour,
      tmbuf.tm_min,
      tmbuf.tm_sec,
      zone);
   } 
return 0;
}



/* ------------ coustum_time_getr --------------- */
int ctime_getr(char ch)
{
time_t t;
struct tm tmbuf;

t = time(NULL);
localtime_r(&t, &tmbuf);

switch(ch){
  case 'y': return(tmbuf.tm_year + 1900);
  case 'm': return(tmbuf.tm_mon + 1);
  case 'd': return(tmbuf.tm_mday);
  case 'h': return(tmbuf.tm_hour);
  case 'i': return(tmbuf.tm_min);
  case 's': return(tmbuf.tm_sec);
  default : break;
  }

return -1;
}


/* ------------ time_getr --------------- */
int time_getr(char buf[], int count)
{
time_t t;
struct tm tmbuf;

t = time(NULL);
localtime_r(&t, &tmbuf);

if(20<=count){
   sprintf(buf,"%04d:%02d:%02d:%02d:%02d:%02d",
      tmbuf.tm_year + 1900,
      tmbuf.tm_mon + 1,
      tmbuf.tm_mday,
      tmbuf.tm_hour,
      tmbuf.tm_min,
      tmbuf.tm_sec);
   }
return 0;
}



